#ifndef MALLOCLOG_H_INCLUDED

extern "C" unsigned dwMemAccessCount;
extern "C" int dwMemAccessMax;

#ifdef MALLOC_LOG
	extern "C" void* __cdecl mallocloga(int size, char* Ident);
	extern "C" void __cdecl freeloga(void* Pointer);
	extern "C" void* __cdecl reallocloga(void* Pointer, int Size);
	extern "C" void __cdecl ListAlloc(int Start = 1);
	extern "C" int __cdecl SaveAllocs(int CompactSize, __int64 Start, __int64 End, char* FileName, void* base, unsigned int base_size, ...);
	extern "C" int __cdecl PackMallocIDS(int start);
	extern "C" int __cdecl RepackMallocIDS();
	extern "C" void __cdecl ReleaseMallocIDS();
	extern "C" void* __cdecl LimitedAlloc(unsigned int size, int AttachBlocks);

	extern "C" int MallocLogCount;
	extern "C" int MallocID;
	extern "C" char OperatorNewIdent[256];

	#define freel(Pointer) freeloga(Pointer)
	#define mallocl(size, ident) mallocloga(size, ident)
	#define reallocl(pointer, size) reallocloga(pointer, size)
	#define SetNewIdent(ident) strcpy(OperatorNewIdent + 6, ident)

	extern "C" int* dwVarAccess;
	extern "C" int* dwPageMap;
	extern "C" int dwVarCount;

#else
	#ifdef CHECK_MALLOC
		#define mallocl(size, ident) ((mallocLogATemp = malloc(size)) ? mallocLogATemp : (void*) breakpoint("malloc"))
		#define reallocl(pointer, size) ((mallocLogATemp = realloc(pointer, size)) ? mallocLogATemp : (void*) breakpoint("malloc"))
	#else
		#define mallocl(size, ident) malloc(size)
		#define reallocl(pointer, size) realloc(pointer, size)
	#endif

	#define freel(lpPtr) free(lpPtr)
	#define SetNewIdent(ident)

	extern "C" void* mallocLogATemp;
#endif

#define MALLOCLOG_H_INCLUDED

#endif

#ifndef CALLED_FROM_GLOBAL_H
#ifdef MALLOC_LOG

	#ifdef VECTORC_RUNTIME
		#define size_t unsigned int
	#endif

	extern void* __cdecl operator new[] (size_t size);
	extern void* __cdecl operator new (size_t size);
	extern void __cdecl operator delete[] (void* pointer);
	extern void __cdecl operator delete (void* pointer);

	#ifdef VECTORC_RUNTIME
		#undef size_t
	#endif

#endif
#endif
